SystemOrganization addCategory: #'PEGWiki-Components'!
SystemOrganization addCategory: #'PEGWiki-Model'!
SystemOrganization addCategory: #'PEGWiki-Tools'!
SystemOrganization addCategory: #'PEGWiki-PEG'!
SystemOrganization addCategory: #'PEGWiki-Resources'!
SystemOrganization addCategory: #'PEGWiki-Examples'!

!ALAppHtml5Canvas methodsFor: '*pegwiki' stamp: 'chc 1/7/2016 18:42'!
textarea
	^ self open: (PWAppTextareaTag on: self)
! !

PEGActor subclass: #PWActor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-PEG'!

!PWActor methodsFor: 'argument' stamp: 'chc 1/2/2016 18:22'!
Bold: flow
	<action: 'Bold' arguments: #(2)>
	^'<b>' , (self collectString: flow) , '</b>'! !

!PWActor methodsFor: 'argument' stamp: 'chc 11/25/2015 19:27'!
Heading1: flow
	<action: 'Heading1' arguments: #(3) >
	^'<h1>' , (self collectString: flow) , '</h1>'! !

!PWActor methodsFor: 'argument' stamp: 'chc 11/25/2015 19:27'!
Heading2: flow
	<action: 'Heading2' arguments: #(3) >
	^'<h2>' , (self collectString: flow) , '</h2>'! !

!PWActor methodsFor: 'argument' stamp: 'chc 11/25/2015 19:27'!
Heading3: flow
	<action: 'Heading3' arguments: #(3) >
	^'<h3>' , (self collectString: flow) , '</h3>'! !

!PWActor methodsFor: 'argument' stamp: 'chc 1/2/2016 18:21'!
Italic: flow
	<action: 'Italic' arguments: #(2)>
	^'<i>' , (self collectString: flow) , '</i>'! !

!PWActor methodsFor: 'argument' stamp: 'chc 11/25/2015 19:27'!
Link: flow
	<action: 'LinkShort' arguments: #( 2 )>
	| linkContent |
	linkContent := self collectString: flow.
	^'<a href="http://www.' , linkContent , '.com">' , linkContent , '</a>'! !

!PWActor methodsFor: 'no-argument' stamp: 'chc 1/2/2016 13:19'!
Page: flow
	<action: 'Page'>
	^'<div>' , (self collectString: flow) , '</div>'! !

!PWActor methodsFor: 'no-argument' stamp: 'chc 11/25/2015 19:28'!
Paragraph: flow
	<action: 'Paragraph'>
	^'<p>' , (self collectString: flow) , '</p>'! !

!PWActor methodsFor: 'private' stamp: 'chc 11/25/2015 19:27'!
collectString: flow
	| string |
	string := String new writing.
	flow do: [:ea| string write: ea].
	^string conclusion! !

!ALJsonResource methodsFor: '*pegwiki' stamp: 'chc 1/20/2016 12:40'!
handlePost: aRequest locator: aLocator
	| request wikiString wikiGrammar parser html |
	request := PWFormatRequest new.
	aRequest readEntityWith: 
		[:in | ALJsonParser  parse: in for: request].
	"put new wiki string in the class var"
	wikiString := request wikiString.
	PWModelConfiguration instance takeValue: wikiString forAttribute: (WAStringAttribute key: #currentString group: #wikidata).
	"make string to put in component"
	wikiGrammar := PEGParser grammarWiki.
	parser := PEGParser parserPEG parse: 'Grammar' stream: wikiGrammar actor: PEGParserParser new.
	html := parser parse: 'Page' stream: wikiString actor: PWActor new.
	self component html: html.
	"return response"
	"do I need a redirect so that the GET is activated?"
 	^ ALResponse 
		type: ALContentType json 
		callback: [ :out | self renderOnStream: out locator: aLocator ]

! !

!ALResponse class methodsFor: '*pegwiki' stamp: 'chc 1/27/2015 15:08'!
unauthorized
	^ self status: 401 reason: 'Unauthorized' details: 'You have not logged in'! !

!ALFormDataParser methodsFor: '*pegwiki' stamp: 'hc 3/11/2016 10:11'!
parseAssociation
	| key value withpluses |
	key := in get.
	in get.
	withpluses := ((in reading ending: [ :e | '&' includes: e ]) rest) printString.
	value := withpluses replaceAll: $+ with: Character space.
	^ key -> value
	
	! !

ALComponentResource subclass: #PWBasicAuthResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Resources'!

!PWBasicAuthResource commentStamp: 'chc 6/22/2015 14:50' prior: 0!
Used by ORAuthApplication. Drops down browser window for username and password.!

!PWBasicAuthResource methodsFor: 'as yet unclassified' stamp: 'chc 6/23/2015 16:39'!
authorized: result locator: aLocator
	| root cookie url |
	root := component rematerialize.
	url := aLocator urlForResource: root asResource.
	cookie := ALCookie name: 'auth' value: result token.
	cookie path: '/'.
	^ (ALResponse seeOther: url)
			setCookie: cookie; 
			yourself! !

!PWBasicAuthResource methodsFor: 'as yet unclassified' stamp: 'chc 2/3/2015 16:08'!
denied
	^ ALResponse status: 401 reason: 'Authentication failed'! !

!PWBasicAuthResource methodsFor: 'as yet unclassified' stamp: 'chc 2/10/2015 15:46'!
handleGet: aRequest locator: aLocator
	| request result authstring |
	(aRequest authorization isNil)
		ifTrue: [^self respondWithChallenge]
		ifFalse: [
	authstring := (aRequest authorization copyAfter: Character space) base64Decoded.
	request := ALAuthenticationRequest withUsername:  (authstring copyUpTo: $:)   password: (authstring copyAfter: $:).
	result := request signal].
	^(result notNil and: [result isSuccess])
		ifTrue: [self authorized: result locator: aLocator]
		ifFalse: [ self denied ]
			! !

!PWBasicAuthResource methodsFor: 'as yet unclassified' stamp: 'chc 2/3/2015 16:15'!
respondWithChallenge
	^ALResponse unauthorized
		wwwAuthenticate: 'Basic Realm = "My Server"';
			yourself! !

ALExample subclass: #ALAsyncExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Components'!

!ALAsyncExample methodsFor: 'as yet unclassified' stamp: 'chc 1/20/2016 12:38'!
renderContentOn: html
	html span
		class: 'counter';
		id: 'count';
		with: '0'.
((PWModel storage at: #render) = 'on') ifTrue: [
	html form id: 'myform'; beMethodPost; with:
		[html textarea name: 'wikiString'; with: [ html text: (PWModelConfiguration instance valueAt: #currentString)].
		 html br. 
		 html input beTypeSubmit ]]. 
	self renderScriptsOn: html! !

!ALAsyncExample methodsFor: 'as yet unclassified' stamp: 'chc 1/11/2016 12:51'!
renderScriptsOn: html
	html script src: 'https://ajax.googleapis.com/ajax/libs/jquery/1.7.2/jquery.min.js'.
	html script src: 'http://localhost:8624/jquery.form.js'.
	html script
		type: 'application/javascript';
		with: [html raw: self libraryScript].
	html script 
		type: 'application/javascript';
		with: [self renderFormScriptOn: html].
	html script
		type: 'application/javascript';
		with: [self renderInitScriptOn: html]! !

ALAsyncExample subclass: #PWConfigPage
	instanceVariableNames: 'integer something'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Components'!

!PWConfigPage methodsFor: 'as yet unclassified' stamp: 'chc 1/7/2016 18:45'!
initialize
	integer := 'off'.
	something := 'Coco Beware'! !

!PWConfigPage methodsFor: 'as yet unclassified' stamp: 'chc 2/1/2016 13:50'!
renderAttribute: anAttribute on: anHtmlCanvas

	! !

!PWConfigPage methodsFor: 'as yet unclassified' stamp: 'chc 3/18/2016 12:54'!
renderContentOn: html
	html form beMethodGet; with:
		[ html p: 'Show wiki syntax form for editing page content: '.
			html input 
			beTypeRadio;
			value: 'on';
			callback: [:str | PWModel storage at: #render put: str ];
			with: [html text: 'On'].
		html br. 
		html input beTypeRadio;
			value: 'off';
			callback: [:str | PWModel storage at: #render put: str ];
			with: [html text: 'Off'].
		html br.
		html input beTypeSubmit; value: 'Save'.
		html br.
		html text: (PWModel storage at: #render) ].
	
		html table with: [ 
			PWModelConfiguration instance groupedAttributes do: [:association| 
					html tr with: [
						html td colspan: '2'; with: [ html h3: (self labelForSelector: association key).
							association value do: [ :attribute |
								self renderAttribute: attribute on: html ]
				 			]]]].
		html br.
		html table
			with: [html tr
				with: [html td with: 'Port'.
					html td with: '8624']].
		html textarea.
		html form beMethodGet; with:
		[html input 
			beTypeText
			value: integer printString;
			size: '100';
			callback: [:str | Compiler evaluate: str unescapePercents "integer := str ""asNumber"];
			with: [].
		html text: integer "asWords"].
		self renderStyleOn: html.
		
		
		
		! !

!PWConfigPage methodsFor: 'as yet unclassified' stamp: 'chc 1/28/2016 12:32'!
renderStyleOn: html
	^ html style: '
			table, tr, td {border: 1px solid green;}'! !

!ALAjaxCounterExample methodsFor: '*pegwiki' stamp: 'chc 1/4/2016 10:49'!
renderFormScriptOn: html
	html raw: 
		'function ConvertFormToJson(form) {
			var array = (form).serializeArray();
			var json = {};
			jQuery.each( array, function () {
			json[this.name] = this.value || '' '';
		});
		return json;
		}

		$(myform).submit(function(event){
		event.preventDefault();

		var json = ConvertFormToJson($(myform));
		console.log(json);

		jsonstring = JSON.stringify(json);
		console.log(jsonstring);

		$.ajax({
		type: "POST",
		url: "'.

	html text: (html context registerResource: self resource) printString.

	html raw: 
		'",
		data: jsonstring,
		success: function (data) {
					var self = this;
					self.state = data;
					$(''#count'').html(self.state.count);
									}
		}) 
							});'! !

!ALAjaxCounterExample methodsFor: '*pegwiki' stamp: 'chc 1/20/2016 12:38'!
resource
	| wikiString wikiGrammar parser html |
	wikiString := PWModelConfiguration instance valueAt: #currentString.
	wikiGrammar := PEGParser grammarWiki.
	parser := PEGParser parserPEG parse: 'Grammar' stream: wikiGrammar actor: PEGParserParser new.
	html := parser parse: 'Page' stream: wikiString actor: PWActor new.
	^ ALJsonResource component: (PWAjaxComponent html: html)! !

ALTextareaTag subclass: #PWAppTextareaTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Components'!

!PWAppTextareaTag methodsFor: 'accessing' stamp: 'chc 1/7/2016 18:39'!
callback: aValuable
	self name: (canvas currentForm registerCallback: aValuable) asString
! !

!PWAppTextareaTag methodsFor: 'accessing' stamp: 'chc 1/7/2016 18:39'!
send: aSelector to: anObject
	self value: (anObject perform: aSelector).
	self callback: [:v | anObject perform: aSelector asMutator with: v]! !

TestCase subclass: #PWActorTests
	instanceVariableNames: 'parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-PEG'!

!PWActorTests commentStamp: '<historical>' prior: 0!
A terminal here is an OrderedCollection that does not contain another OrderedCollection. A terminal's contents is chars or strings. In the #grammarWiki that could be: 

Bold <- "*" Flow{"*"}

Angle brackets (i.e. {}) show that something is optional. To create a bold word you need an asterisk befor a or line. It will not contain any further OrderedCollections.  !

!PWActorTests methodsFor: 'page structure' stamp: 'chc 1/3/2016 01:41'!
setUp
	| grammar |
	grammar := PEGParser grammarWiki.
	parser := PEGParser parserPEG parse: 'Grammar' stream: grammar actor: PEGParserParser new.
	! !

!PWActorTests methodsFor: 'single node ' stamp: 'chc 2/23/2016 12:45'!
testBold
	| result |
	result := parser parse: 'Bold' stream: '*Taco Bell*' actor: PWActor new.
	self assert: ( '<b>Taco Bell</b>' = result )! !

!PWActorTests methodsFor: 'double node' stamp: 'chc 2/23/2016 12:42'!
testBullet1
	| result |
	result := parser parse: 'Bullet1' stream: ' *First Item' actor: PWActor new.
	self assert: ( '<li>First Item</li>' = result )! !

!PWActorTests methodsFor: 'single node ' stamp: 'chc 2/23/2016 12:43'!
testCode
	| result |
	result := parser parse: 'Code' stream: '{{{
code
}}}' actor: PWActor new.
	self assert: ( '<pre>
code
</pre>' = result )! !

!PWActorTests methodsFor: 'single node ' stamp: 'chc 2/23/2016 12:46'!
testHeading1
	| result |
	result := parser parse: 'Heading1' stream: '  = BigDay =
				' actor: PWActor new.
	self assert: ( '<h1>BigDay</h1>' = result )! !

!PWActorTests methodsFor: 'single node ' stamp: 'chc 2/23/2016 12:46'!
testHeading2
	| result |
	result := parser parse: 'Heading2' stream: '  == BigDay ==
				' actor: PWActor new.
	self assert: ( '<h2>BigDay</h2>' = result )! !

!PWActorTests methodsFor: 'single node ' stamp: 'chc 2/23/2016 12:46'!
testHeading3
	| result |
	result := parser parse: 'Heading3' stream: '  === BigDay ===
				' actor: PWActor new.
	self assert: ( '<h3>BigDay</h3>' = result )! !

!PWActorTests methodsFor: 'single node ' stamp: 'chc 2/23/2016 12:47'!
testItalic
	| result |
	result := parser parse: 'Italic' stream: '_Taco Bell_' actor: PWActor new.
	self assert: ( '<i>Taco Bell</i>' = result )! !

!PWActorTests methodsFor: 'single node ' stamp: 'chc 2/23/2016 12:47'!
testLink
	| result |
	result := parser parse: 'LinkShort' stream: '[abc]' actor: PWActor new.
	self assert: ( '<a href="http://www.abc.com">abc</a>' = result )! !

!PWActorTests methodsFor: 'page structure' stamp: 'chc 2/23/2016 12:46'!
testPage
	| result |
	result := parser parse: 'Page' stream: 'Taco Bell' actor: PWActor new.
	self assert: ( '<div><p>Taco Bell</p></div>' = result )! !

TestCase subclass: #PWPEGParserTests
	instanceVariableNames: 'parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-PEG'!

!PWPEGParserTests commentStamp: '<historical>' prior: 0!
A terminal here is an OrderedCollection that does not contain another OrderedCollection. A terminal's contents is chars or strings. In the #grammarWiki that could be: 

Bold <- "*" Flow{"*"}

Angle brackets (i.e. {}) show that something is optional. To create a bold word you need an asterisk befor a or line. It will not contain any further OrderedCollections.  !

!PWPEGParserTests methodsFor: 'empty space identifiers' stamp: 'chc 2/23/2016 23:04'!
setUp
	| grammar |
	grammar := PEGParser grammarWiki.
	parser := PEGParser parserPEG parse: 'Grammar' stream: grammar actor: PEGParserParser new.
	! !

!PWPEGParserTests methodsFor: 'empty space identifiers' stamp: 'chc 2/23/2016 23:00'!
testEmpty
	| result oc1 oc2 |
	result := parser parse: 'Empty' stream: '
	' reading actor: nil.
	oc1 := OrderedCollection new. 
	oc2 := OrderedCollection new.
	oc2 add: Character tab.
	oc1 add: oc2.
	self assert: ( oc1 = result )! !

!PWPEGParserTests methodsFor: 'empty space identifiers' stamp: 'chc 2/23/2016 23:00'!
testLIneCharacter
	| result oc1 oc2 |
	result := parser parse: 'LineCharacter' stream: '
	' reading actor: nil.
	oc1 := OrderedCollection new. 
	oc2 := OrderedCollection new.
	oc2 add: Character tab.
	oc1 add: oc2.
	self assert: ( oc1 = result )! !

!PWPEGParserTests methodsFor: 'empty space identifiers' stamp: 'chc 2/23/2016 23:12'!
testLine
	| result |
	result := parser parse: 'LinkShort' stream: '[abc]' actor: nil.
	self assert: ( '<a href="http://www.abc.com">abc</a>' = result )! !

!PWPEGParserTests methodsFor: 'empty space identifiers' stamp: 'chc 2/23/2016 23:00'!
testWhitespace
	| result oc1 oc2 chars |
	result := parser parse: 'Whitespace' stream: '		  ' actor: nil.
	oc1 := OrderedCollection new. 
	oc2 := OrderedCollection new.
	oc1 add: Character tab; add: Character tab; add: Character space; add: Character space.
	chars := oc2 add: oc1.
	self assert: ( chars = result )! !

TestCase subclass: #WAConfigurationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

!WAConfigurationTest methodsFor: 'as yet unclassified' stamp: 'mb 4/23/2006 15:15'!
testLinearization
	"from http://www.webcom.com/haahr/dylan/linearization-oopsla96.html"
	| root boat dayBoat wheelBoat engineLess pedalWheelBoat smallMultihull smallCatamaran pedalo |
	root _ WAUserConfiguration new.
	boat _ WAUserConfiguration new addAncestor: root; yourself.
	dayBoat _ WAUserConfiguration new addAncestor: boat; yourself.
	wheelBoat _ WAUserConfiguration new addAncestor: boat; yourself.
	engineLess _ WAUserConfiguration new addAncestor: dayBoat; yourself.
	pedalWheelBoat _ WAUserConfiguration new addAncestor: engineLess; addAncestor: wheelBoat; yourself.
	smallMultihull _ WAUserConfiguration new addAncestor: dayBoat; yourself.
	smallCatamaran _ WAUserConfiguration new addAncestor: smallMultihull; yourself.
	pedalo _ WAUserConfiguration new addAncestor: pedalWheelBoat; addAncestor: smallCatamaran; yourself.

	self assert: pedalWheelBoat allAncestors = (Array with: engineLess with: dayBoat with: wheelBoat with: boat with: root).
	self assert: smallCatamaran allAncestors = (Array with: smallMultihull with: dayBoat with: boat with: root).
	self assert: pedalo allAncestors = ((Array with: pedalWheelBoat with: engineLess with: smallCatamaran with: smallMultihull), (Array with: dayBoat with: wheelBoat with: boat with: root)).! !

ALFormExample subclass: #PWFormExamples
	instanceVariableNames: 'radio integer2 integer3 dropdown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Examples'!

!PWFormExamples methodsFor: 'as yet unclassified' stamp: 'hc 3/10/2016 10:30'!
initialize
	integer := 'start string 2'.
	radio := ''.
	integer2 := 0.
	integer3 := 0.
	dropdown := 'peaches'! !

!PWFormExamples methodsFor: 'as yet unclassified' stamp: 'chc 2/2/2016 11:28'!
renderContentOn: html
	super renderContentOn: html! !

!PWFormExamples methodsFor: 'as yet unclassified' stamp: 'hc 2/25/2016 12:26'!
renderFormsOn: html
	html p: 'Two Integer Inputs:'.
	html form beMethodGet; with:
		[html input 
			beTypeText
			value: integer2 printString;
			callback: [:str | integer2 := str asNumber];
			with: [].
		html input 
			beTypeText
			value: integer3 printString;
			callback: [:str | integer3 := str asNumber];
			with: [].
		html input beTypeSubmit.
		html br.
		html text: integer2 asWords.
		html br.
		html text: integer3 asWords].
	html p: 'Radio Button:'.
	html form beMethodGet; with:
		[html input beTypeRadio
			value: 'male';
			callback: [:str | radio := str ].
		html br. 
		html input beTypeRadio
			value: 'female';
			callback: [:str | radio := str ].
		html br.
		html input beTypeSubmit.
		html text: radio ].
	html p: 'Ordered List:'.
	html ol:
		[#('apples' 'oranges' 'grapes') do:
			[:i | 
			html li:
				[html text: i ]]].
	html p: 'Unordered List:'.
	html ul:
		[#('apples' 'oranges' 'grapes') do:
			[:each | 
			html li: each ]].
	html p: 'Drop-down List:'.
	html form beMethodGet; with:
		[html select 
				callback: [:str| dropdown := str ];
					with: [html option with: [html text: 'superduper'].
						   html option with: [html text: 'another'].
						    html option with: [html text: 'garycooper']].
		html input beTypeSubmit.
		html br.
		html p: dropdown].

! !

!Object methodsFor: '*pegwiki' stamp: 'chc 1/28/2016 12:41'!
labelForSelector: aSymbol
	^ aSymbol asCapitalizedPhrase
! !

Object subclass: #PEGWiki
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Tools'!

!PEGWiki class methodsFor: 'as yet unclassified' stamp: 'chc 1/25/2016 11:31'!
start

	| authenticator app | 
	authenticator := ALMemoryAuthenticator new. 
	authenticator register: 'chriscunnington'
 					username: (PWModelConfiguration instance valueAt: #username)
 					password: (PWModelConfiguration instance valueAt: #password).

	app := ALExampleApplication new.
	app addFactory: [:term | ALAuthenticationRelay destination: term
						authenticator: authenticator 
						shunt: nil].
	(ALServer on: (PWModelConfiguration instance valueAt: #port) application: app) start 

! !

Object subclass: #PWAjaxComponent
	instanceVariableNames: 'html'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-PEG'!

!PWAjaxComponent class methodsFor: 'as yet unclassified' stamp: 'chc 1/2/2016 09:16'!
html: aString
	^self basicNew
		initializeWithWikiString: aString! !

!PWAjaxComponent methodsFor: 'accessing' stamp: 'chc 1/2/2016 09:17'!
html 
	^html! !

!PWAjaxComponent methodsFor: 'accessing' stamp: 'chc 1/4/2016 10:32'!
html: anObject
	html := anObject! !

!PWAjaxComponent methodsFor: 'as yet unclassified' stamp: 'chc 1/2/2016 09:16'!
initializeWithWikiString: aString
	html := aString
	! !

!PWAjaxComponent methodsFor: 'as yet unclassified' stamp: 'chc 1/2/2016 09:17'!
renderOn: json
	json object:
		[json name: 'count' value: html]! !

Object subclass: #PWFormatRequest
	instanceVariableNames: 'wikiString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Resources'!

!PWFormatRequest class methodsFor: 'as yet unclassified' stamp: 'chc 8/18/2015 13:41'!
username: username password: password
	^ (self withUsername: username password: password) signal! !

!PWFormatRequest class methodsFor: 'as yet unclassified' stamp: 'chc 8/18/2015 13:41'!
withUsername: username password: password
	^ self basicNew
		initializeWithUsername: username password: password! !

!PWFormatRequest methodsFor: 'initialization' stamp: 'chc 8/18/2015 13:42'!
initializeWithUsername: aUsername password: aPassword
	self initialize.
	! !

!PWFormatRequest methodsFor: 'interpreting' stamp: 'chc 8/18/2015 13:53'!
name: aString value: anObject
	aString = 'wikiString' ifTrue: [wikiString := anObject].
	! !

!PWFormatRequest methodsFor: 'interpreting' stamp: 'chc 8/18/2015 13:41'!
object: aBlock
	aBlock value
	! !

!PWFormatRequest methodsFor: 'accessing' stamp: 'chc 8/18/2015 13:42'!
wikiString

	^ wikiString! !

!PWFormatRequest methodsFor: 'accessing' stamp: 'chc 8/18/2015 13:42'!
wikiString: anObject

	wikiString := anObject! !

Object subclass: #PWModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

PWModel class
	instanceVariableNames: 'storage'!

!PWModel commentStamp: 'chc 1/25/2016 11:04' prior: 0!
this is a simple model with a dictionary in a class variable. it stands alone from the rest of the classes in this category!

PWModel class
	instanceVariableNames: 'storage'!

!PWModel class methodsFor: 'as yet unclassified' stamp: 'chc 1/18/2016 22:43'!
storage
	^storage ! !

!PWModel class methodsFor: 'as yet unclassified' stamp: 'chc 1/18/2016 22:42'!
storage: anObject
	storage := anObject! !

Object subclass: #WAConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

!WAConfiguration class methodsFor: 'instance creation' stamp: 'avi 1/30/2004 16:39'!
new
	^ self basicNew initialize! !

!WAConfiguration class methodsFor: 'as yet unclassified' stamp: 'jf 2/9/2004 19:46'!
readUserConfigurationsFrom: aStream
	| ini |
	ini _ INIFile readFrom: aStream.
	self registeredConfigurationsDo:
		[:config |
		(ini includesSection: config name) ifTrue:
			[config clear.
			(ini section: config name) associationsDo:
				[:assoc | assoc value ifNotNil:
					[(config hasAttributeNamed: assoc key)
						ifTrue: [config valueAt: assoc key put: assoc value]]]]]! !

!WAConfiguration class methodsFor: 'as yet unclassified' stamp: 'jf 2/9/2004 19:20'!
writeUserConfigurationsOn: aStream
	| ini |
	ini _ INIFile new.
	self registry keysAndValuesDo:
		[:key :value | (ini section: key) addAll: value localValues].
	ini writeOn: aStream! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 16:27'!
addAncestorsTo: tempCollection linearization: linearCollection
	(linearCollection includes: self)
		ifTrue: [tempCollection do: [:ea | linearCollection add: ea before: self].
				tempCollection removeAllSuchThat: [:ea | true]]
		ifFalse: [tempCollection add: self.
				self ancestors isEmpty
					ifTrue: [linearCollection addAll: tempCollection.
							tempCollection removeAllSuchThat: [:ea | true]]
					ifFalse: [self ancestors do: [:ea | ea addAncestorsTo: tempCollection linearization: linearCollection]]]! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 17:16'!
allAncestors
	| temp linear |
	temp _ OrderedCollection new.
	linear _ OrderedCollection new.
	self addAncestorsTo: temp linearization: linear.
	^ linear allButFirst asArray! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 17:16'!
allAncestorsDo: aBlock
	self allAncestors do: aBlock! !

!WAConfiguration methodsFor: 'attributes' stamp: 'avi 2/1/2004 14:53'!
allAttributes
	^ Array streamContents:
		[:s | 
		self withAllAncestorsDo: [:ea | s nextPutAll: ea attributes]]
! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 3/24/2004 11:59'!
allPotentialAncestors
	^ #()! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/2/2004 14:43'!
ancestors
	^ #()! !

!WAConfiguration methodsFor: 'attributes' stamp: 'avi 2/1/2004 14:54'!
attributeNamed: aSymbol
	^ self allAttributes
		detect: [:ea | ea key = aSymbol]
		ifNone: [self error: 'No attribute named ', aSymbol printString]
! !

!WAConfiguration methodsFor: 'attributes' stamp: 'jf 2/1/2004 17:34'!
attributes
	^ #()! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 1/30/2004 16:32'!
attributesAndValuesDo: keyValueBlock
	^ self allAttributes do:
		[:ea |
		keyValueBlock value: ea value: (self valueForAttribute: ea)]! !

!WAConfiguration methodsFor: 'attributes' stamp: 'avi 2/5/2004 13:21'!
groupedAttributes
	| dict sorted |
	dict _ Dictionary new.
	sorted _ SortedCollection sortBlock: [:a :b | a key <= b key].
	self allAttributes do:
		[:ea |
		(dict at: ea group ifAbsentPut: [SortedCollection sortBlock: [:a :b | a key <= b key]])
			add: ea].
	dict associationsDo:
		[:assoc |
		sorted add: assoc].
	^ sorted
		! !

!WAConfiguration methodsFor: 'testing' stamp: 'avi 1/30/2004 16:21'!
hasAttributeNamed: aSymbol
	^ self allAttributes anySatisfy: [:ea | ea key = aSymbol]! !

!WAConfiguration methodsFor: 'testing' stamp: 'avi 2/3/2004 22:59'!
hasLocalValueForAttribute: anAttribute
	self localValueAt: anAttribute key ifAbsent: [^ false].
	^ true! !

!WAConfiguration methodsFor: 'testing' stamp: 'avi 3/23/2004 14:53'!
hasMutableAncestry
	^ false! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 3/23/2004 12:40'!
inheritedValueAndSourceAt: aSymbol do: aBlock
	self allAncestorsDo:
		[:ea |
		(ea localValueAt: aSymbol ifAbsent: [])
			ifNotNilDo: [:val | ^ aBlock value: val value: ea]].
	^ nil! !

!WAConfiguration methodsFor: 'testing' stamp: 'jf 2/1/2004 18:03'!
inheritsFrom: aConfiguration
	^ self allAncestors anySatisfy: [:ea | ea = aConfiguration]
	
	! !

!WAConfiguration methodsFor: 'initializing' stamp: 'avi 2/2/2004 14:34'!
initialize
	! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 2/3/2004 22:58'!
localValueAt: aSymbol ifAbsent: absentBlock
	self subclassResponsibility! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 3/23/2004 12:40'!
lookupValueAt: aSymbol
	^ self inheritedValueAndSourceAt: aSymbol do: [:value :source | value]! !

!WAConfiguration methodsFor: 'accessing' stamp: 'avi 3/24/2004 11:55'!
name
	^ self subclassResponsibility! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 3/23/2004 14:47'!
potentialAncestors
	^ self allPotentialAncestors reject: [:ea | ea = self or: [(self inheritsFrom: ea) or: [ea inheritsFrom: self]]]! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 2/3/2004 22:58'!
valueAt: aSymbol
	^ self localValueAt: aSymbol ifAbsent: [self lookupValueAt: aSymbol]! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 2/3/2004 22:59'!
valueForAttribute: anAttribute
	^ self valueAt: anAttribute key! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 16:28'!
withAllAncestorsDo: aBlock
	aBlock value: self.
	^ self allAncestorsDo: aBlock! !

WAConfiguration subclass: #WASystemConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

WASystemConfiguration class
	instanceVariableNames: 'instance'!

WASystemConfiguration class
	instanceVariableNames: 'instance'!

WASystemConfiguration subclass: #WAAuthConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

!WAAuthConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:32'!
ancestors
	^ Array with: (WARenderLoopConfiguration new)! !

!WAAuthConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 21:12'!
attributes
	^ Array
		with: (WAStringAttribute key: #login group: #authentication)
		with: (WAStringAttribute key: #password group: #authentication)
		
! !

!WAAuthConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 21:07'!
mainClass
	^ WAAuthMain! !

WASystemConfiguration subclass: #WAGlobalConfiguration
	instanceVariableNames: ''
	classVariableNames: 'DeploymentMode'
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

!WAGlobalConfiguration class methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2006 23:39'!
initialize
	DeploymentMode ifNil: [self setDevelopmentMode]! !

!WAGlobalConfiguration class methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2006 23:35'!
setDeploymentMode
	DeploymentMode _ true! !

!WAGlobalConfiguration class methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2006 23:36'!
setDevelopmentMode
	DeploymentMode _ false! !

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 9/11/2005 13:00'!
attributes
	^ Array 
		with: ((WAListAttribute key: #serverProtocol group: #server) options: #(http https))
		with: (WAStringAttribute key: #serverHostname group: #server)
		with: (WANumberAttribute key: #serverPort group: #server)
		with: (WABooleanAttribute key: #deploymentMode)! !

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2006 23:35'!
deploymentMode
	^ DeploymentMode! !

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:00'!
serverPort
	^ 80! !

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:00'!
serverProtocol
	^ #http! !

WASystemConfiguration subclass: #WARenderLoopConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:33'!
ancestors
	^ Array with: (WASessionConfiguration new)! !

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 9/11/2005 14:30'!
attributes
	^ Array
		with: ((WAListAttribute key: #rootComponent) options: self rootComponents)
		with: (WAStringAttribute key: #resourceBaseUrl group: #server)! !

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 17:02'!
errorHandler
	^ WAWalkbackErrorHandler! !

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:24'!
mainClass
	^ WARenderLoopMain! !

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 19:09'!
rootComponents
	^ (WAComponent allSubclasses select: [:ea | ea canBeRoot]) asSortedCollection: [:a :b | a name <= b name]! !

WASystemConfiguration subclass: #WASessionConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:33'!
ancestors
	^ Array with: WAGlobalConfiguration new! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/27/2005 17:57'!
attributes
	^ Array
		with: (WANumberAttribute key: #sessionExpirySeconds)
		with: ((WAListAttribute key: #sessionClass) options: self sessionClasses)
		with: ((WAListAttribute key: #mainClass) options: self mainClasses)
		with: ((WAListAttribute key: #errorHandler) options: self errorHandlerClasses)
		with: (WABooleanAttribute key: #useSessionCookie)! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:10'!
errorHandler
	^ WASimpleErrorHandler! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 4/7/2004 13:59'!
errorHandlerClasses
	^ WAErrorHandler allSubclasses! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 12:20'!
mainClasses
	^ WAMain allSubclasses! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:05'!
sessionClass
	^ WASession! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:04'!
sessionClasses
	^ WASession withAllSubclasses! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:05'!
sessionExpirySeconds
	^ 600! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/12/2005 21:42'!
useSessionCookie
	^ false! !

!WASystemConfiguration class methodsFor: 'as yet unclassified' stamp: 'lr 5/3/2006 09:44'!
instance
	^ instance ifNil: [ instance _ self basicNew initialize ]! !

!WASystemConfiguration class methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:33'!
new
	^ self instance! !

!WASystemConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:01'!
attributes
	self subclassResponsibility ! !

!WASystemConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/3/2004 23:00'!
localValueAt: aSymbol ifAbsent: absentBlock
	^ (self respondsTo: aSymbol)
		ifTrue: [self perform: aSymbol]
		ifFalse: [absentBlock value]! !

!WASystemConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:31'!
name
	^ self class name! !

WAConfiguration subclass: #WAUserConfiguration
	instanceVariableNames: 'values ancestors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

WAUserConfiguration subclass: #PWModelConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

PWModelConfiguration class
	instanceVariableNames: 'instance'!

PWModelConfiguration class
	instanceVariableNames: 'instance'!

!PWModelConfiguration class methodsFor: 'as yet unclassified' stamp: 'chc 1/20/2016 12:22'!
instance
	^ instance ifNil: [ instance _ self basicNew initialize ]! !

!PWModelConfiguration class methodsFor: 'as yet unclassified' stamp: 'chc 1/20/2016 12:23'!
new
	^ self instance! !

!PWModelConfiguration methodsFor: 'as yet unclassified' stamp: 'chc 1/25/2016 12:11'!
attributes
	^ Array
		with: (WAStringAttribute key: #login group: #authentication)
		with: (WAStringAttribute key: #password group: #authentication)
		with: (WANumberAttribute key: #port group: #server)
		with: (WAStringAttribute key: #currentString group: #wikisyntax)
! !

!WAUserConfiguration class methodsFor: 'as yet unclassified' stamp: 'avi 11/17/2005 00:27'!
initialize
	self allInstances do: [:ea | ea instVarNamed: 'ancestors' put: (ea ancestors collect: [:c  | [c instVarNamed: 'parent'] ifError: [c]])] 
	! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:39'!
addAncestor: aConfiguration
	(self inheritsFrom: aConfiguration)
		ifFalse: [ancestors add: aConfiguration]! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:39'!
allPotentialAncestors
	^ WASystemConfiguration allSubclasses collect: [:ea | ea new]! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:39'!
ancestors
	^ ancestors! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
clear
	values _ Dictionary new.! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
clearValueForAttribute: anAttribute
	values removeKey: anAttribute key ifAbsent: []! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:39'!
hasMutableAncestry
	^ true! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:39'!
initialize
	super initialize.
	values _ Dictionary new.
	ancestors _ OrderedCollection new.! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
localValueAt: aSymbol ifAbsent: errorBlock
	^ values at: aSymbol ifAbsent: errorBlock! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
localValues
	| dict |
	dict _ Dictionary new.
	self allAttributes do:
		[:attr | (self localValueAt: attr key ifAbsent: [nil])
			ifNotNilDo: [:value | dict at: attr key put: (attr stringForValue: value)]].
		
	^ dict! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
localValues: aDictionary
	self allAttributes do:
		[:attr | (aDictionary at: attr key ifAbsent: [nil])
			ifNotNilDo: [:string | self valueAt: attr key put: (attr valueFromString: string)]]! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
overrideAttribute: anAttribute
	self takeValue: (self valueForAttribute: anAttribute) forAttribute: anAttribute! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:39'!
removeAncestor: aConfiguration
	ancestors remove: aConfiguration ifAbsent: []! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 15:21'!
takeValue: anObject forAttribute: anAttribute
	^ anObject ifNotNil: [values at: anAttribute key put: anObject]! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
valueAt: aSymbol put: anObject
	^ self takeValue: anObject forAttribute: (self attributeNamed: aSymbol)! !

Object subclass: #WAConfigurationAttribute
	instanceVariableNames: 'key group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

WAConfigurationAttribute subclass: #WABooleanAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

!WABooleanAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:11'!
accept: aVisitor with: anObject
	^ aVisitor visitBooleanAttribute: self with: anObject! !

!WABooleanAttribute methodsFor: 'as yet unclassified' stamp: 'avi 4/26/2004 14:42'!
valueFromString: aString
	^ aString = 'true'
		ifTrue: [true]
		ifFalse: [aString = 'false'
				 ifTrue: [false]
				 ifFalse: [self error: 'Invalid value for boolean attribute']]
! !

!WAConfigurationAttribute class methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 13:15'!
key: aSymbol
	^ self key: aSymbol group: nil! !

!WAConfigurationAttribute class methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 13:14'!
key: keySymbol group: groupSymbol
	^ self basicNew initializeWithKey: keySymbol group: groupSymbol! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 17:12'!
accept: aVisitor with: anObject
	self subclassResponsibility ! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 13:21'!
group
	^ group ifNil: [#general]! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 13:14'!
initializeWithKey: keySymbol group: groupSymbol
	key _ keySymbol.
	group _ groupSymbol! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 16:40'!
key
	^ key! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'mbany 4/14/2005 12:28'!
stringForValue: anObject
	^ anObject displayString! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'jf 2/8/2004 17:07'!
valueFromString: aString
	self subclassResponsibility ! !

WAConfigurationAttribute subclass: #WAListAttribute
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

!WAListAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:13'!
accept: aVisitor with: anObject
	^ aVisitor visitListAttribute: self with: anObject! !

!WAListAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:12'!
options
	^ options! !

!WAListAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:11'!
options: aCollection
	options _ aCollection! !

!WAListAttribute methodsFor: 'as yet unclassified' stamp: 'mbany 4/14/2005 12:29'!
valueFromString: aString
	^ self options
		detect: [:ea | ea displayString = aString]
		ifNone: [self error: 'No matching list option']! !

WAConfigurationAttribute subclass: #WANumberAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

!WANumberAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:13'!
accept: aVisitor with: anObject
	^ aVisitor visitNumberAttribute: self with: anObject! !

!WANumberAttribute methodsFor: 'as yet unclassified' stamp: 'jf 2/8/2004 17:10'!
valueFromString: aString
	^ Number readFrom: aString! !

WAConfigurationAttribute subclass: #WAStringAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

WAStringAttribute subclass: #WAPasswordAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki-Model'!

!WAPasswordAttribute methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 21:02'!
accept: aVisitor with: anObject
	^ aVisitor visitPasswordAttribute: self with: anObject! !

!WAStringAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 17:12'!
accept: aVisitor with: anObject
	^ aVisitor visitStringAttribute: self with: anObject! !

!WAStringAttribute methodsFor: 'as yet unclassified' stamp: 'lr 5/3/2006 09:56'!
valueFromString: aString
	^ aString isEmptyOrNil ifFalse: [ aString ]! !

!String methodsFor: '*pegwiki' stamp: 'chc 1/28/2016 12:41'!
asCapitalizedPhrase
	|read words currentWord capitalizedWord|
	(self noneSatisfy: [:ea | ea isLowercase] ) ifTrue: [^ self].
	words _ WriteStream on: String new.
	read _ ReadStream on: self.
	[read atEnd] whileFalse:
		[currentWord _ WriteStream on: String new.
		currentWord nextPut: read next.
		[|x| x _ read peek. x isNil or: [x isUppercase]] whileFalse:
			[currentWord nextPut: read next].
		capitalizedWord _ currentWord contents capitalized.
			(#(Of In At A Or To By) includes: capitalizedWord)
				ifTrue: [capitalizedWord _ capitalizedWord asLowercase].
		words nextPutAll: capitalizedWord.
		words nextPutAll: ' '].
	words skip: -1.
	^ words contents ! !
WAGlobalConfiguration initialize!
WAUserConfiguration initialize!
